Index: src/view/WaveTrackV.h
===================================================================
--- src/view/WaveTrackV.h	(revision 0)
+++ src/view/WaveTrackV.h	(working copy)
@@ -0,0 +1,75 @@
+
+class AUDACITY_DLL_API WaveTrackV :
+virtual public TrackV
+{
+public:
+   WaveTrackV(void);
+   ~WaveTrackV(void);
+
+   void DrawWaveform(WaveTrack *track,
+                     wxDC & dc, const wxRect & r, const ViewInfo *viewInfo, 
+                     bool drawEnvelope, bool drawSamples, bool drawSliders,
+                     bool dB, bool muted);
+
+   void DrawClipWaveform(WaveTrack *track, WaveClip *clip,
+                         wxDC & dc, const wxRect & r, const ViewInfo *viewInfo,
+                         bool drawEnvelope, bool drawSamples, bool drawSliders,
+                         bool dB, bool muted);
+
+   // Waveform utility functions
+
+   void DrawWaveformBackground(wxDC & dc, const wxRect &r, const double env[],
+                               float zoomMin, float zoomMax, bool dB,
+                               const sampleCount where[],
+                               sampleCount ssel0, sampleCount ssel1,
+                               bool drawEnvelope, bool bIsSyncLockSelected);
+
+   void DrawMinMaxRMS(wxDC & dc, const wxRect & r, const double env[],
+                      float zoomMin, float zoomMax, bool dB,
+                      const float min[], const float max[], const float rms[],
+                      const int bl[], bool showProgress, bool muted);
+
+   void DrawIndividualSamples(wxDC & dc, const wxRect & r,
+                              float zoomMin, float zoomMax, bool dB,
+                              WaveClip *clip,
+                              double t0, double pps, double h,
+                              bool drawSamples, bool showPoints, bool muted);
+
+   void DrawEnvelope(wxDC & dc, const wxRect & r, const double env[],
+                     float zoomMin, float zoomMax, bool dB);
+   void DrawEnvLine(wxDC & dc, const wxRect & r, int x, int y, int cy, bool top);
+
+   void DrawTimeSlider(WaveTrack *track,
+                       wxDC & dc, const wxRect & r, const ViewInfo *viewInfo,
+                       bool rightwards);
+
+   // Helper: draws background with selection rect
+   static void DrawBackgroundWithSelection(wxDC *dc, const wxRect &r,
+         Track *track, wxBrush &selBrush, wxBrush &unselBrush,
+         double sel0, double sel1, double h, double pps);
+
+   // Helper: draws the "sync-locked" watermark tiled to a rectangle
+   static void DrawSyncLockTiles(wxDC *dc, wxRect r);
+
+   wxBrush blankSelectedBrush;
+   wxBrush dragsampleBrush;// for samples which are draggable.
+   wxBrush sampleBrush;
+   wxBrush selectedBrush;
+   wxBrush unselectedBrush;
+
+   wxPen clippedPen;
+   wxPen muteClippedPen;
+   wxPen muteRmsPen;
+   wxPen muteSamplePen;
+   wxPen samplePen;
+   wxPen rmsPen;
+
+   // Preference values
+   long mShowClipping;        // "/GUI/ShowClipping"
+   float mdBrange;            // "/GUI/EnvdBRange"
+   bool mIsGrayscale;         // "/Spectrum/Grayscale"
+};
+
+extern int GetWaveYPos(float value, float min, float max,
+			  int height, bool dB, bool outer, float dBr, 
+			  bool clip);
Index: src/WaveClip.h
===================================================================
--- src/WaveClip.h	(revision 11311)
+++ src/WaveClip.h	(working copy)
@@ -228,13 +228,17 @@
    virtual XMLTagHandler *HandleXMLChild(const wxChar *tag);
    virtual void WriteXML(XMLWriter &xmlFile);
 
-   // Cache of values to colour pixels of Spectrogram - used by TrackArtist
-   SpecPxCache    *mSpecPxCache;
-
    // AWD, Oct 2009: for pasting whitespace at the end of selection
    bool GetIsPlaceholder() { return mIsPlaceholder; };
    void SetIsPlaceholder(bool val) { mIsPlaceholder = val; };
 
+   SpecPxCache *GetSpecPxCache(){return mSpecPxCache;}
+   void SetSpecPxCache(SpecPxCache *c) 
+   {  SpecPxCache *oldcache=mSpecPxCache;
+      mSpecPxCache=c;
+      delete oldcache;
+   }
+
 protected:
    wxRect mDisplayRect;
 
@@ -264,6 +268,9 @@
 
    // AWD, Oct. 2009: for whitespace-at-end-of-selection pasting
    bool mIsPlaceholder;
+
+   // Cache of values to colour pixels of Spectrogram - used by TrackArtist
+   SpecPxCache    *mSpecPxCache;
 };
 
 #endif
Index: win/audacity.sln
===================================================================
--- win/audacity.sln	(revision 11311)
+++ win/audacity.sln	(working copy)
@@ -1,77 +1,54 @@
-Microsoft Visual Studio Solution File, Format Version 10.00
-# Visual C++ Express 2008
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "Audacity", "Projects\Audacity\Audacity.vcproj", "{1D64095C-F936-4FCF-B609-56E9DDF941FA}"
-	ProjectSection(ProjectDependencies) = postProject
-		{8A1C2514-85DD-4AE2-9CF3-3183B66C537D} = {8A1C2514-85DD-4AE2-9CF3-3183B66C537D}
-		{A64FFB5D-0CF0-43EE-9DE3-C72260864BFF} = {A64FFB5D-0CF0-43EE-9DE3-C72260864BFF}
-		{D5AB2D87-51DC-4277-A9AB-2A6018D0E947} = {D5AB2D87-51DC-4277-A9AB-2A6018D0E947}
-		{C0FE933B-4AF7-4ACD-95E8-ACD3A73F1400} = {C0FE933B-4AF7-4ACD-95E8-ACD3A73F1400}
-		{EC3F5835-C486-4970-8A6B-A0700F4B3637} = {EC3F5835-C486-4970-8A6B-A0700F4B3637}
-		{6C7DC635-26FB-419A-B69A-7ECBBB068245} = {6C7DC635-26FB-419A-B69A-7ECBBB068245}
-		{B28C9F3F-FF0E-4FEC-844C-685390B8AC06} = {B28C9F3F-FF0E-4FEC-844C-685390B8AC06}
-		{5284D863-3813-479F-BBF0-AC234E216BC6} = {5284D863-3813-479F-BBF0-AC234E216BC6}
-		{F4B4A272-4ED3-4951-A6EE-B7BAAC1C4952} = {F4B4A272-4ED3-4951-A6EE-B7BAAC1C4952}
-		{727D6675-67EE-4D0B-9DC1-177A0AF741F0} = {727D6675-67EE-4D0B-9DC1-177A0AF741F0}
-		{7ABA0F80-94AE-4E82-AB89-2E1258212D59} = {7ABA0F80-94AE-4E82-AB89-2E1258212D59}
-		{3A76129B-55AB-4D54-BAA7-08F63ED52569} = {3A76129B-55AB-4D54-BAA7-08F63ED52569}
-		{A52BBEA5-8B02-4147-8734-5D9BBF4D1177} = {A52BBEA5-8B02-4147-8734-5D9BBF4D1177}
-		{3DDDCAA9-276D-4FC3-A15C-485F7B9B24CC} = {3DDDCAA9-276D-4FC3-A15C-485F7B9B24CC}
-		{38C2C6B1-FBF8-4C5C-BB90-63F996083F56} = {38C2C6B1-FBF8-4C5C-BB90-63F996083F56}
-		{8C69F7B6-684F-48D9-9057-8912CA3DAA8B} = {8C69F7B6-684F-48D9-9057-8912CA3DAA8B}
-		{D96C7BE1-E3F1-4767-BBBB-320E082CE425} = {D96C7BE1-E3F1-4767-BBBB-320E082CE425}
-		{7AA41BED-41B0-427A-9148-DEA40549D158} = {7AA41BED-41B0-427A-9148-DEA40549D158}
-		{A61E2BF1-21AA-4118-B0D8-FD3D53DB892E} = {A61E2BF1-21AA-4118-B0D8-FD3D53DB892E}
-		{F00717F2-67C8-44E1-AF00-541DFA9CB7F2} = {F00717F2-67C8-44E1-AF00-541DFA9CB7F2}
-		{A939AAF8-44F1-4CE7-9DD0-7A6E99814857} = {A939AAF8-44F1-4CE7-9DD0-7A6E99814857}
-	EndProjectSection
+Microsoft Visual Studio Solution File, Format Version 11.00
+# Visual C++ Express 2010
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "Audacity", "Projects\Audacity\Audacity.vcxproj", "{1D64095C-F936-4FCF-B609-56E9DDF941FA}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "soundtouch", "Projects\soundtouch\soundtouch.vcproj", "{EC3F5835-C486-4970-8A6B-A0700F4B3637}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "soundtouch", "Projects\soundtouch\soundtouch.vcxproj", "{EC3F5835-C486-4970-8A6B-A0700F4B3637}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "expat", "Projects\expat\expat.vcproj", "{38C2C6B1-FBF8-4C5C-BB90-63F996083F56}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "expat", "Projects\expat\expat.vcxproj", "{38C2C6B1-FBF8-4C5C-BB90-63F996083F56}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libflac", "Projects\libflac\libflac.vcproj", "{6C7DC635-26FB-419A-B69A-7ECBBB068245}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libflac", "Projects\libflac\libflac.vcxproj", "{6C7DC635-26FB-419A-B69A-7ECBBB068245}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libflac++", "Projects\libflac++\libflac++.vcproj", "{B28C9F3F-FF0E-4FEC-844C-685390B8AC06}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libflac++", "Projects\libflac++\libflac++.vcxproj", "{B28C9F3F-FF0E-4FEC-844C-685390B8AC06}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libid3tag", "Projects\libid3tag\libid3tag.vcproj", "{D96C7BE1-E3F1-4767-BBBB-320E082CE425}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libid3tag", "Projects\libid3tag\libid3tag.vcxproj", "{D96C7BE1-E3F1-4767-BBBB-320E082CE425}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libmad", "Projects\libmad\libmad.vcproj", "{A52BBEA5-8B02-4147-8734-5D9BBF4D1177}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libmad", "Projects\libmad\libmad.vcxproj", "{A52BBEA5-8B02-4147-8734-5D9BBF4D1177}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libnyquist", "Projects\libnyquist\libnyquist.vcproj", "{7AA41BED-41B0-427A-9148-DEA40549D158}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libnyquist", "Projects\libnyquist\libnyquist.vcxproj", "{7AA41BED-41B0-427A-9148-DEA40549D158}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libresample", "Projects\libresample\libresample.vcproj", "{F00717F2-67C8-44E1-AF00-541DFA9CB7F2}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libresample", "Projects\libresample\libresample.vcxproj", "{F00717F2-67C8-44E1-AF00-541DFA9CB7F2}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libsamplerate", "Projects\libsamplerate\libsamplerate.vcproj", "{3DDDCAA9-276D-4FC3-A15C-485F7B9B24CC}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libsamplerate", "Projects\libsamplerate\libsamplerate.vcxproj", "{3DDDCAA9-276D-4FC3-A15C-485F7B9B24CC}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libsndfile", "Projects\libsndfile\libsndfile.vcproj", "{F4B4A272-4ED3-4951-A6EE-B7BAAC1C4952}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libsndfile", "Projects\libsndfile\libsndfile.vcxproj", "{F4B4A272-4ED3-4951-A6EE-B7BAAC1C4952}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libogg", "Projects\libogg\libogg.vcproj", "{A939AAF8-44F1-4CE7-9DD0-7A6E99814857}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libogg", "Projects\libogg\libogg.vcxproj", "{A939AAF8-44F1-4CE7-9DD0-7A6E99814857}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "portmixer", "Projects\portmixer\portmixer.vcproj", "{3A76129B-55AB-4D54-BAA7-08F63ED52569}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "portmixer", "Projects\portmixer\portmixer.vcxproj", "{3A76129B-55AB-4D54-BAA7-08F63ED52569}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libvorbis", "Projects\libvorbis\libvorbis.vcproj", "{727D6675-67EE-4D0B-9DC1-177A0AF741F0}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libvorbis", "Projects\libvorbis\libvorbis.vcxproj", "{727D6675-67EE-4D0B-9DC1-177A0AF741F0}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "portaudio-v19", "Projects\portaudio-v19\portaudio-v19.vcproj", "{7ABA0F80-94AE-4E82-AB89-2E1258212D59}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "portaudio-v19", "Projects\portaudio-v19\portaudio-v19.vcxproj", "{7ABA0F80-94AE-4E82-AB89-2E1258212D59}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "locale", "Projects\locale\locale.vcproj", "{BE9F28C5-058A-45F5-B2C1-D077BC058AAE}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "locale", "Projects\locale\locale.vcxproj", "{BE9F28C5-058A-45F5-B2C1-D077BC058AAE}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "filedialog", "Projects\filedialog\filedialog.vcproj", "{5284D863-3813-479F-BBF0-AC234E216BC6}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "filedialog", "Projects\filedialog\filedialog.vcxproj", "{5284D863-3813-479F-BBF0-AC234E216BC6}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "mod-script-pipe", "Projects\mod-script-pipe\mod-script-pipe.vcproj", "{85774A29-EA2F-4A40-994F-6BE593D847A5}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "mod-script-pipe", "Projects\mod-script-pipe\mod-script-pipe.vcxproj", "{85774A29-EA2F-4A40-994F-6BE593D847A5}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libvamp", "Projects\libvamp\libvamp.vcproj", "{A61E2BF1-21AA-4118-B0D8-FD3D53DB892E}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libvamp", "Projects\libvamp\libvamp.vcxproj", "{A61E2BF1-21AA-4118-B0D8-FD3D53DB892E}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "twolame", "Projects\twolame\twolame.vcproj", "{8C69F7B6-684F-48D9-9057-8912CA3DAA8B}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "twolame", "Projects\twolame\twolame.vcxproj", "{8C69F7B6-684F-48D9-9057-8912CA3DAA8B}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "portsmf", "Projects\portsmf\portsmf.vcproj", "{8A1C2514-85DD-4AE2-9CF3-3183B66C537D}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "portsmf", "Projects\portsmf\portsmf.vcxproj", "{8A1C2514-85DD-4AE2-9CF3-3183B66C537D}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "sbsms", "Projects\sbsms\sbsms.vcproj", "{A64FFB5D-0CF0-43EE-9DE3-C72260864BFF}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "sbsms", "Projects\sbsms\sbsms.vcxproj", "{A64FFB5D-0CF0-43EE-9DE3-C72260864BFF}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libscorealign", "Projects\libscorealign\libscorealign.vcproj", "{C0FE933B-4AF7-4ACD-95E8-ACD3A73F1400}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libscorealign", "Projects\libscorealign\libscorealign.vcxproj", "{C0FE933B-4AF7-4ACD-95E8-ACD3A73F1400}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "portmidi", "Projects\portmidi\portmidi.vcproj", "{D5AB2D87-51DC-4277-A9AB-2A6018D0E947}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "portmidi", "Projects\portmidi\portmidi.vcxproj", "{D5AB2D87-51DC-4277-A9AB-2A6018D0E947}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "help", "Projects\help\help.vcproj", "{02F94A40-586A-4403-8464-13B50801FFEC}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "help", "Projects\help\help.vcxproj", "{02F94A40-586A-4403-8464-13B50801FFEC}"
 EndProject
 Global
 	GlobalSection(SolutionConfigurationPlatforms) = preSolution
